
/*
 *  repeaterSubscribeTimer.cpp,v 1.8 2001/03/08 21:27:32 jhill Exp
 *
 *                    L O S  A L A M O S
 *              Los Alamos National Laboratory
 *               Los Alamos, New Mexico 87545
 *
 *  Copyright, 1986, The Regents of the University of California.
 *
 *  Author: Jeff Hill
 *
 */

#include "iocinf.h"

repeaterSubscribeTimer::repeaterSubscribeTimer ( udpiiu &iiuIn, epicsTimerQueue &queueIn ) :
    timer ( queueIn.createTimer ( *this ) ), iiu ( iiuIn ), 
        attempts ( 0 ), registered ( false ), once ( false )
{
    this->timer.start ( 10.0 );
}

repeaterSubscribeTimer::~repeaterSubscribeTimer ()
{
    delete & this->timer;
}

epicsTimerNotify::expireStatus repeaterSubscribeTimer::expire ()
{
    static const unsigned nTriesToMsg = 50;
    if ( this->attempts > nTriesToMsg && ! this->once ) {
        ca_printf (
    "Unable to contact CA repeater after %u tries\n", nTriesToMsg);
        ca_printf (
    "Silence this message by starting a CA repeater daemon\n");
        this->once = true;
    }

    this->iiu.repeaterRegistrationMessage ( this->attempts );
    this->attempts++;

    if ( this->registered ) {
        return noRestart;
    }
    else {
        return expireStatus ( restart, 1.0 );
    }
}

void repeaterSubscribeTimer::show ( unsigned /* level */ ) const
{
}

void repeaterSubscribeTimer::confirmNotify ()
{
    this->registered = true;
}
